/*
 * Copyright (c) 2003-2007 Erez Zadok
 * Copyright (c) 2003-2007 Stony Brook University
 * Copyright (c) 2003-2007 The Research Foundation of State University of New York
 * Copyright (c) 2004-2007 Nikolai Joukov
 * Copyright (c) 2003-2005 Akshat Aranya
 * Copyright (c) 2006-2007 Gopala Surya
 *
 * For specific licensing information, see the COPYING file distributed with
 * this package, or get one from ftp://ftp.filesystems.org/pub/fist/COPYING.
 *
 * This Copyright notice must be kept intact and distributed with all
 * fistgen sources INCLUDING sources generated by fistgen.
 */

#ifndef __STREAM_HEADER_H
#define __STREAM_HEADER_H

/*
 * This is intended for specifying the version.
 * It is used to enforce compatibility between the
 * parser library and the trace module.
 */

typedef unsigned long version_t;



#define TRACEFS_STREAM_MAGIC 0xCAFED00D

/* This structure must remain unchanged between versions */
struct stream_header {
    unsigned long magic;
    version_t version;
};



#define VERSION_STR "0.0.1"
#define VERSION_CODE 1
#define VERSION(a,b,c) (((a) << 16) + ((b) << 8) + (c))


#define MAJOR_VERSION(ver) (((ver) >> 16) & 0xff)
#define MINOR_VERSION(ver) (((ver) >> 8) & 0xff)
#define REVISION(ver)   ((ver) & 0xff)

#endif
