/*
 * Copyright (c) 2003-2007 Erez Zadok
 * Copyright (c) 2003-2007 Stony Brook University
 * Copyright (c) 2003-2007 The Research Foundation of State University of New York
 * Copyright (c) 2004-2007 Nikolai Joukov
 * Copyright (c) 2003-2005 Akshat Aranya
 * Copyright (c) 2006-2007 Gopala Surya
 */

#ifndef __UTIL_H
#define __UTIL_H

#include <openssl/evp.h>
#include <openssl/blowfish.h>

int make_key(struct decrypt_params *params, char *strkey);
int hmac_make_key(struct cksum_params *params, char *strkey);
char *get_str_arg_type(field_t arg);
char *hex2byte(char *digits);
char *byte2hex(char byte);
char *type_to_str_type(op_t type);

/* encryption related stuff */
enum {
	ANON_UID,
	ANON_GID,
	ANON_PID,
	ANON_PATHNAME,
	ANON_PNAME,
	ANON_STR,
	ANON_TIMESTAMP,
	ANON_MAX_FIELDS
};



struct key_struct {
	int valid;
	char *name;
	char key[EVP_MAX_KEY_LENGTH];
	BF_KEY *bf_ctx;
	EVP_CIPHER_CTX *evp_ctx;
};

extern struct key_struct anon_keys[];
#endif
