/*
 * Copyright (c) 2004-2007 Erez Zadok
 * Copyright (c) 2004-2007 Stony Brook University
 * Copyright (c) 2004-2007 The Research Foundation of State University of New York
 * Copyright (c) 2004-2007 Nikolai Joukov
 *
 * For specific licensing information, see the COPYING file distributed with
 * this package, or get one from ftp://ftp.filesystems.org/pub/fist/COPYING.
 *
 * This Copyright notice must be kept intact and distributed with all
 * fistgen sources INCLUDING sources generated by fistgen.
 */

#ifndef __HASH_H
#define __HASH_H

#include <stdlib.h>


struct hash_entry_s;
typedef struct hash_s
{
  unsigned int tablesize;
  unsigned int number_of_objects; //For determining when to rehash
  struct hash_entry_s** table_tail; //Array of Pointers storing the tail
  struct hash_entry_s** table;
} hash_t;

//Public Functions
int hash_init(hash_t* hash,int size);
int hash_add(hash_t* hash,void* key,int keylen,void* value); //Returns 0 on success
int hash_add_allow_dupes(hash_t* hash,void* key,int keylen,void* value); //Returns 0 on success
int hash_add_replace_dupes(hash_t* hash,void* key,int keylen,void* value); //Returns 0 on success
void* hash_remove(hash_t* hash,void* key,int keylen); //returns NULL on fail
void* hash_find(hash_t* hash,void* key,int keylen); //returns value
int hash_clear(hash_t* hash); //Clears all entries
int hash_destroy(hash_t* hash); //Destroys the hash
int hash_destroy_all(hash_t* hash); //Destroys the hash and hashed objects

#endif //__HASH_H
