/*
 * Copyright (c) 2004-2007 Erez Zadok
 * Copyright (c) 2004-2007 Stony Brook University
 * Copyright (c) 2004-2007 The Research Foundation of State University of New York
 * Copyright (c) 2004-2007 Nikolai Joukov
 * Copyright (c) 2006-2007 Gopala Surya
 *
 * For specific licensing information, see the COPYING file distributed with
 * this package, or get one from ftp://ftp.filesystems.org/pub/fist/COPYING.
 *
 * This Copyright notice must be kept intact and distributed with all
 * fistgen sources INCLUDING sources generated by fistgen.
 */

#ifndef __TRFS_PRE_H
#define __TRFS_PRE_H

#include "debug.h"
#include "res_manager.h"

//For saved field
#define CONTEXT_SAVED_INUM 0
#define CONTEXT_SAVED_DENTRY_PTR 1
#define CONTEXT_SAVED_FILE_PTR 2
#define CONTEXT_SAVED_RAT_LOC 3

//For saved_fid_flags field
#define CONTEXT_SAVED_FID_INODE_GET   1
#define CONTEXT_SAVED_FID_INODE_PUT   2
#define CONTEXT_SAVED_FID_DENTRY_GET  4
#define CONTEXT_SAVED_FID_DENTRY_PUT  8
#define CONTEXT_SAVED_FID_FILE_GET   16
#define CONTEXT_SAVED_FID_FILE_PUT   32

struct context {
    pid_t pid;
    char *pname;
    int len;
    int ret; /* return value for ops that return an integer */
    //char *pargs;
    void *other;
    int other_fields_filled;
    int args[MAX_ARGS];
    char arg_str[MAX_ARGS]; //set to 1 if arg is a memory buffer
    timeval_t time;
    unsigned int expected_retval;
    int status;
    void* private; //Private pointer - use me and abuse me!

    /*
     * This field is for storing tracefs arguments used for optimizations.
     * ex. inode numbers for res_manager_dentry_from_inum() or
     *     optimizations with res_manager_reuse_rat_objects()
     *
     * saved[0] = ARG_INUM
     * saved[1] = ARG_DENTRY_PTR;
     * saved[2] = ARG_FILE_PTR;
     * saved[3] = ARG_RAT_LOC;
     */
    int saved[4];
  //This bitmask specifies which object (file,dentry,inode) and what op (get,put) should be performed by res_manager
    short saved_fid_flags;
};

typedef struct page_list_s {
  long value;
  long data_loc; //Rat Location of the data
  struct page_list_s* next;
}page_list_t;

#endif
